=== tools/clang/lib/Makefile ===
##===- lib/Makefile ----------------------------------------*- Makefile -*-===##
# 
#                     The LLVM Compiler Infrastructure
#
# This file is distributed under the University of Illinois Open Source
# License. See LICENSE.TXT for details.
# 
##===----------------------------------------------------------------------===##
CLANG_LEVEL := ..

PARALLEL_DIRS = Headers Basic Lex Parse AST Sema CodeGen Analysis \
                StaticAnalyzer Rewrite Serialization Frontend FrontendTool Index Driver

include $(CLANG_LEVEL)/Makefile
