=== tools/clang/tools/CMakeLists.txt ===
add_subdirectory(libclang)
add_subdirectory(c-index-test)
add_subdirectory(driver)
