=== debian/changelog ===
clang (2.9-13) unstable; urgency=low

  * Provide libclang0 & libclang-dev packages (Closes: #598738)
  * Provide a VENDOR for the clang version (obviously: Debian)
  * Add the Debian revision in the clang version information

 -- Sylvestre Ledru <sylvestre@debian.org>  Thu, 29 Sep 2011 17:29:42 +0200

clang (2.9-12) unstable; urgency=low

  * Explicit the dependency on libstdc++6-4.6-dev due to the multiarch
    changes (Closes: #640547)

 -- Sylvestre Ledru <sylvestre@debian.org>  Wed, 21 Sep 2011 11:27:29 +0200

clang (2.9-11) unstable; urgency=low

  * Add g++ headers of version 4.5 and 4.6 to the search path.
  * Backport upstream support of g++-4.6 headers (commit 130057 & 128809)

 -- Sylvestre Ledru <sylvestre@debian.org>  Sun, 04 Sep 2011 21:58:34 +0200

clang (2.9-10) unstable; urgency=low

  * Update gcc lib paths regarding the recent changes in the gcc multiarch paths
    (Closes: #639962)

 -- Sylvestre Ledru <sylvestre@debian.org>  Thu, 01 Sep 2011 17:05:03 +0200

clang (2.9-9) unstable; urgency=low

  * Update dependency on libstdc++6-4.5-dev to libstdc++6-4.6-dev
  * Pass default ld flags --hash-style=both --no-copy-dt-needed-entries
    Doko's request (Closes: #637869)
  * Add gcc 4.5.3 and 4.6.1 in the search path

 -- Sylvestre Ledru <sylvestre@debian.org>  Wed, 31 Aug 2011 00:25:19 +0200

clang (2.9-8) unstable; urgency=low

  * CFLAGS are now also multiarch. clang will now search in
    /usr/include/HOST_MULTIARCH_TRIPLET/ for C headers (Closes: #633739)
    (LP: #764870)

 -- Sylvestre Ledru <sylvestre@debian.org>  Thu, 11 Aug 2011 15:07:13 +0200

clang (2.9-7) unstable; urgency=low

  * debian/patches/15-64_triple.patch, debian/patches/14-multiarchi386.diff,
    debian/patches/13-multiarch-newpath.patch removed
  * debian/patches/13-search-path-dpkg-based.patch: Better detection of the
    gcc lib path.
    It is now using dpkg-architecture to get the information and putting
    the information in a define of the code. Thanks to Julien Blache for the
    idea.

 -- Sylvestre Ledru <sylvestre@debian.org>  Thu, 23 Jun 2011 21:46:59 +0200

clang (2.9-6) unstable; urgency=low

  * debian/patches/14-multiarchi386.diff: Specific case for x86 multi arch
    (Closes: #629861)
  * debian/patches/15-64_triple.patch: Fix the 64 bits detection of the gcc
    libs

 -- Sylvestre Ledru <sylvestre@debian.org>  Sat, 18 Jun 2011 19:15:39 +0200

clang (2.9-5) unstable; urgency=low

  * debian/control.in/clang, debian/control: Revert the change to
    libstdc++6-4.6-dev because of bug #9472. Should be fixed in clang 2.10/3.0
  * control.in/source: Pierre removed from the uploaders
  * control.in/*llvm*, packages.d/llvm.mk, debhelper.in/*llvm*, llvm.binfmt: 
    remove some llvm related and useless files in the context of clang

 -- Sylvestre Ledru <sylvestre@debian.org>  Sun, 12 Jun 2011 23:39:03 +0200

clang (2.9-4) unstable; urgency=low

  * debian/patches/12-gcc-4.6.patch: Support of gcc 4.6 (Closes: #627131)
  * debian/control.in/clang, debian/control: Dependency switch from 
    libstdc++6-4.5-dev to libstdc++6-4.6-dev
  * debian/patches/13-multiarch-newpath.patch: Multiarch support
    (Closes: #629861)

 -- Sylvestre Ledru <sylvestre@debian.org>  Sun, 12 Jun 2011 11:14:49 +0200

clang (2.9-3) unstable; urgency=low

  * llvm-snapshot.install, llvm-gcc-4.2.links & llvm-gcc-4.2.install removed
    (deprecated)
  * debian/rules.d/vars.mk: useless rule removed

  [ Michael Wild ]
  * debian/patches/11-searchMultiArchLibDir.patch: Adds the multi-arch library
    directory to the file search path (Closes: #629594)

 -- Sylvestre Ledru <sylvestre@debian.org>  Thu, 09 Jun 2011 22:48:32 +0200

clang (2.9-2) unstable; urgency=low

  [ Michael Wild ]
  * debian/patches/searchGCCPath.patch: Remove because it is Ubuntu-specific
  * debian/patches/10-handleWheezySid.patch: Make Debian wheezy/sid known to
    Clang
  * debian/rules: Pass include-paths at configure-time such that the broken
    automatic searching is disabled (see
    http://llvm.org/bugs/show_bug.cgi?id=6907). Only specify 32/64-bit
    include-dir suffix on 32/64-bit architectures.
    (Closes: #594820) (LP: #764870)

 -- Sylvestre Ledru <sylvestre@debian.org>  Tue, 31 May 2011 10:49:52 +0200

clang (2.9-1) unstable; urgency=low

  * debian/packages.d/tools.mk: clang C++ headers detection was broken. Set them
    by default. Thanks to Michael Wild for doing my work 
  * debian/control: libstdc++6-4.5-dev added as dependency of clang
    (LP: #779404)
  * debian/patches/searchGCCPath.patch: Added a path to the search of the C++
    header (Closes: #594820) (LP: #764870)
  * debian/control.in/llvm-gcc-4.2, debian/control.in/llvm-snapshot,
    debian/packages.d/llvm-gcc-4.2.mk, debian/packages.d/llvm-snapshot.mk:
    removed
  * Upload in unstable

 -- Sylvestre Ledru <sylvestre@debian.org>  Sun, 22 May 2011 11:18:43 +0200

clang (2.9-1~exp1) experimental; urgency=low

  * New upstream release

 -- Sylvestre Ledru <sylvestre@debian.org>  Tue, 12 Apr 2011 21:21:24 +0200

clang (2.8-2) unstable; urgency=low

  * debian/changelog: Upload to unstable
  * debian/control.in/source:
    - Update of the tags Vcs-Svn & Vcs-Browser
    - Standards-Version updated to 3.9.2
  * debian/man/*.1: Man pages for scan-build and scan-view included. Thanks to
    Gildo Fiorito (Closes: #606909)
  * debian/watch: watch file added

 -- Sylvestre Ledru <sylvestre@debian.org>  Wed, 16 Feb 2011 08:18:58 +0100

clang (2.8-1) experimental; urgency=low

  * Sync from Ubuntu
  * New upstream release (Closes: #599531)
    * Warning if NULL is assigned to int (Closes: #585168)
    * clang -ftrapv: UNREACHABLE on 64-bit off_t addition (Closes: #608539)
    * Incorrect implementation of __builtin_expect() (Closes: #588711)
  * Add myself to the uploaders.
  * Add clang as cc and c++ alternatives groups (Closes: #592011)
  * Switch to dpkg-source 3.0 (quilt) format

 -- Sylvestre Ledru <sylvestre@debian.org>  Mon, 14 Feb 2011 00:25:18 +0100


